<?php
/**
 * WoWRoster.net WoWRoster
 *
 * LICENSE: Licensed under the Creative Commons
 *          "Attribution-NonCommercial-ShareAlike 2.5" license
 *
 * @copyright  2002-2007 WoWRoster.net
 * @license    http://creativecommons.org/licenses/by-nc-sa/2.5   Creative Commons "Attribution-NonCommercial-ShareAlike 2.5"
 * @version    SVN: $Id: install.def.php $
 * @link       http://www.wowroster.net
 * @package    MadeBy
 * @subpackage Installer
*/

if ( !defined('IN_ROSTER') )
{
    exit('Detected invalid access to this file!');
}

/**
 * Installer for MadeBy Addon
 * @package    MadeBy
 * @subpackage Installer
 */
class madebyInstall
{
	var $active = true;
	var $icon = 'inv_gizmo_02';

	var $version = '1.9.9.7';
	var $wrnet_id = '0';
	var $fullname = 'MadeBy_title_addon';
	var $description = 'MadeBy_desc';
	var $credits = array(
		array(	"name"=>	"DS",
				"info"=>	"Display Made By ..."),
		array(  "name"=>	"Cybrey",
				"info"=>	"Original Addon Developer -- Mods by Thorus"),
	);

	/**
	 * Install Function
	 *
	 * @return bool
	 */
	function install()
	{
		global $installer, $roster;

		// Master and menu entries
		$installer->add_config("'1','startpage','made_conf','display','master'");
		$installer->add_config("'110','made_conf',NULL,'blockframe','menu'");
		$installer->add_config("'120','made_pref',NULL,'blockframe','menu'");

		//Display settings
		$installer->add_config("'1000', 'display_recipe_icon', '1', 'radio{Show^1|Hide^0', 'made_conf'");
		$installer->add_config("'1010', 'display_recipe_name', '1', 'radio{Show^1|Hide^0', 'made_conf'");
		$installer->add_config("'1020', 'display_recipe_skill', '1', 'radio{Show^1|Hide^0', 'made_conf'");
		$installer->add_config("'1030', 'display_recipe_level', '1', 'radio{Show^1|Hide^0', 'made_conf'");
		$installer->add_config("'1040', 'display_recipe_tooltip', '1', 'radio{Show^1|Hide^0', 'made_conf'");
		$installer->add_config("'1050', 'display_recipe_type', '0', 'radio{Show^1|Hide^0', 'made_conf'");
		$installer->add_config("'1060', 'display_recipe_reagents', '1', 'radio{Show^1|Hide^0', 'made_conf'");
		$installer->add_config("'1070', 'display_recipe_makers', '1', 'radio{Show^1|Hide^0', 'made_conf'");
		$installer->add_config("'1080', 'display_recipe_makers_count', '3', 'select{1^1|2^2|3^3|4^4|5^5|6^6|7^7|8^8|9^9|10^10', 'made_conf'");
		$installer->add_config("'1090', 'display_prof_bar', '1', 'radio{Show^1|Hide^0', 'made_conf'");
		$installer->add_config("'1100', 'default_sort_by', 'type', 'select{Sort by Type^type|Sort by Level^level', 'made_conf'");
		$installer->add_config("'1110', 'display_multilanguage', '1', 'radio{Auto^1|No^0|All^2', 'made_conf'");
		$installer->add_config("'1120', 'display_missing', '1', 'radio{Show^1|Hide^0', 'made_conf'");
		
		//recipe settings
		$installer->add_config("'2000', 'Alchemy', '1', 'radio{Show^1|Hide^0', 'made_pref'");
		$installer->add_config("'2010', 'Blacksmithing', '1', 'radio{Show^1|Hide^0', 'made_pref'");
		$installer->add_config("'2020', 'Cooking', '1', 'radio{Show^1|Hide^0', 'made_pref'");
		$installer->add_config("'2030', 'Enchanting', '1', 'radio{Show^1|Hide^0', 'made_pref'");
		$installer->add_config("'2040', 'Engineering', '1', 'radio{Show^1|Hide^0', 'made_pref'");
		$installer->add_config("'2050', 'FirstAid', '0', 'radio{Show^1|Hide^0', 'made_pref'");
		$installer->add_config("'2060', 'Jewelcrafting', '1', 'radio{Show^1|Hide^0', 'made_pref'");
		$installer->add_config("'2070', 'Leatherworking', '1', 'radio{Show^1|Hide^0', 'made_pref'");
		$installer->add_config("'2080', 'Mining', '0', 'radio{Show^1|Hide^0', 'made_pref'");
		$installer->add_config("'2090', 'Tailoring', '1', 'radio{Show^1|Hide^0', 'made_pref'");

		$installer->add_menu_button('MadeBy_menu','guild','','inv_gizmo_02');
		$installer->add_menu_button('MadeBy_menu','realm','','inv_gizmo_02');

		return true;
	}

	/**
	 * Upgrade Function
	 *
	 * @param string $oldversion
	 * @return bool
	 */
	function upgrade($oldversion)
	{
		global $installer, $roster;

		$installer->remove_all_config();

		// Master and menu entries
		$installer->add_config("'1','startpage','made_conf','display','master'");
		$installer->add_config("'110','made_conf',NULL,'blockframe','menu'");
		$installer->add_config("'120','made_pref',NULL,'blockframe','menu'");

		//Display settings
		$installer->add_config("'1000', 'display_recipe_icon', '1', 'radio{Show^1|Hide^0', 'made_conf'");
		$installer->add_config("'1010', 'display_recipe_name', '1', 'radio{Show^1|Hide^0', 'made_conf'");
		$installer->add_config("'1020', 'display_recipe_skill', '1', 'radio{Show^1|Hide^0', 'made_conf'");
		$installer->add_config("'1030', 'display_recipe_level', '1', 'radio{Show^1|Hide^0', 'made_conf'");
		$installer->add_config("'1040', 'display_recipe_tooltip', '1', 'radio{Show^1|Hide^0', 'made_conf'");
		$installer->add_config("'1050', 'display_recipe_type', '0', 'radio{Show^1|Hide^0', 'made_conf'");
		$installer->add_config("'1060', 'display_recipe_reagents', '1', 'radio{Show^1|Hide^0', 'made_conf'");
		$installer->add_config("'1070', 'display_recipe_makers', '1', 'radio{Show^1|Hide^0', 'made_conf'");
		$installer->add_config("'1080', 'display_recipe_makers_count', '3', 'select{1^1|2^2|3^3|4^4|5^5|6^6|7^7|8^8|9^9|10^10', 'made_conf'");
		$installer->add_config("'1090', 'display_prof_bar', '1', 'radio{Show^1|Hide^0', 'made_conf'");
		$installer->add_config("'1100', 'default_sort_by', 'type', 'select{Sort by Type^type|Sort by Level^level', 'made_conf'");
		$installer->add_config("'1110', 'display_multilanguage', '1', 'radio{Auto^1|No^0|All^2', 'made_conf'");
		$installer->add_config("'1120', 'display_missing', '1', 'radio{Show^1|Hide^0', 'made_conf'");
		
		//recipe settings
		$installer->add_config("'2000', 'Alchemy', '1', 'radio{Show^1|Hide^0', 'made_pref'");
		$installer->add_config("'2010', 'Blacksmithing', '1', 'radio{Show^1|Hide^0', 'made_pref'");
		$installer->add_config("'2020', 'Cooking', '1', 'radio{Show^1|Hide^0', 'made_pref'");
		$installer->add_config("'2030', 'Enchanting', '1', 'radio{Show^1|Hide^0', 'made_pref'");
		$installer->add_config("'2040', 'Engineering', '1', 'radio{Show^1|Hide^0', 'made_pref'");
		$installer->add_config("'2050', 'FirstAid', '0', 'radio{Show^1|Hide^0', 'made_pref'");
		$installer->add_config("'2060', 'Jewelcrafting', '1', 'radio{Show^1|Hide^0', 'made_pref'");
		$installer->add_config("'2070', 'Leatherworking', '1', 'radio{Show^1|Hide^0', 'made_pref'");
		$installer->add_config("'2080', 'Mining', '0', 'radio{Show^1|Hide^0', 'made_pref'");
		$installer->add_config("'2090', 'Tailoring', '1', 'radio{Show^1|Hide^0', 'made_pref'");

		return true;
	}

	/**
	 * Un-Install Function
	 *
	 * @return bool
	 */
	function uninstall()
	{
		global $installer, $roster;

		$installer->remove_all_config();
		$installer->remove_all_menu_button();

		return true;
	}
}
